VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "mswinsck.ocx"
Begin VB.MDIForm frmMain 
   BackColor       =   &H8000000C&
   Caption         =   "ignitionServices"
   ClientHeight    =   6810
   ClientLeft      =   165
   ClientTop       =   855
   ClientWidth     =   4740
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "MDIForm1"
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox Picture1 
      Align           =   1  'Align Top
      Appearance      =   0  'Flat
      BackColor       =   &H80000002&
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H80000008&
      Height          =   855
      Left            =   0
      ScaleHeight     =   855
      ScaleWidth      =   4740
      TabIndex        =   1
      Top             =   0
      Width           =   4740
      Begin VB.Label Label1 
         BackStyle       =   0  'Transparent
         Caption         =   "ignitionServices"
         BeginProperty Font 
            Name            =   "Franklin Gothic Medium"
            Size            =   15.75
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H80000009&
         Height          =   495
         Left            =   840
         TabIndex        =   2
         Top             =   165
         Width           =   2775
      End
      Begin VB.Image Image1 
         Height          =   720
         Left            =   40
         Picture         =   "frmMain.frx":3A0A
         Top             =   40
         Width           =   720
      End
   End
   Begin VB.PictureBox picTray 
      Align           =   1  'Align Top
      BorderStyle     =   0  'None
      Height          =   255
      Left            =   0
      Picture         =   "frmMain.frx":48D4
      ScaleHeight     =   255
      ScaleWidth      =   4740
      TabIndex        =   0
      Top             =   855
      Visible         =   0   'False
      Width           =   4740
   End
   Begin VB.Timer timNoMax 
      Interval        =   1
      Left            =   1200
      Top             =   2640
   End
   Begin MSWinsockLib.Winsock wsMain 
      Left            =   510
      Top             =   500
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuConnect 
         Caption         =   "&Connect"
      End
      Begin VB.Menu mnuDisconnect 
         Caption         =   "&Disconnect"
         Enabled         =   0   'False
      End
   End
   Begin VB.Menu mnuTools 
      Caption         =   "&Tools"
      Begin VB.Menu mnuMain 
         Caption         =   "&Main Setup"
      End
      Begin VB.Menu mnuServerConfig 
         Caption         =   "&Server Configuration"
      End
   End
   Begin VB.Menu mnuServices 
      Caption         =   "&Services"
      Begin VB.Menu mnuNickServ 
         Caption         =   "&Nickname Services"
      End
      Begin VB.Menu mnuChanServ 
         Caption         =   "&Channel Services"
      End
   End
   Begin VB.Menu mnuWindow 
      Caption         =   "&Window"
      WindowList      =   -1  'True
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'ignitionServices is (C)  Keith Gable, Nigel Jones and Reid Burke.
'----------------------------------------------------
'You must include this notice in any modifications you make. You must additionally
'follow the GPL's provisions for sourcecode distribution and binary distribution.
'If you are not familiar with the GPL, please read LICENSE.TXT.
'(you are welcome to add a "Based On" line above this notice, but this notice must
'remain intact!)
'Released under the GNU General Public License
'Contact information: Keith Gable (Ziggy) <ziggy@ignition-project.com>
'                     Nigel Jones (DigiGuy) <digiguy@ignition-project.com>
'                     Reid Burke  (AirWalk) <airwalk@ignition-project.com>
'
'
' $Id: frmMain.frm,v 1.18 2004/08/22 22:07:28 ziggythehamster Exp $
'
'
'This program is free software.
'You can redistribute it and/or modify it under the terms of the
'GNU General Public License as published by the Free Software Foundation; either version 2 of the License,
'or (at your option) any later version.
'
'This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY.
'Without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
'See the GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License along with this program.
'if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

Option Explicit
Option Base 0
Public DataCache As String
Public ShownCollision As Boolean

Public Sub LoadConfiguration()
InternalDebug "*** loading configuration"
Beginning:
'On Error Resume Next
Dim F As Integer
Dim tmpVar As String
Dim tmpLine() As String
F = FreeFile
If Dir(App.Path & "\services.conf") <> vbNullString Then
  Open App.Path & "\services.conf" For Input As F
  Do
    Line Input #F, tmpVar
    If Left(tmpVar, 1) = " " Then GoTo NextLine
    If Left(tmpVar, 1) = "#" Then GoTo NextLine
    If Left(tmpVar, 1) = ";" Then GoTo NextLine
    If Left(tmpVar, 1) = "[" Then GoTo NextLine
    If tmpVar = vbNullString Then GoTo NextLine
    
    tmpLine = Split(tmpVar, "=")
    Select Case UCase(tmpLine(0))
      Case "NICKSERV":
        If tmpLine(1) = "0" Then NickServ = False Else NickServ = True
      Case "CHANSERV":
        If tmpLine(1) = "0" Then ChanServ = False Else ChanServ = True
      Case "MEMOSERV":
        If tmpLine(1) = "0" Then MemoServ = False Else MemoServ = True
      Case "OPERSERV":
        If tmpLine(1) = "0" Then OperServ = False Else OperServ = True
      Case "SERVER":
        Server = AllBounds(tmpLine)
      Case "DISPLAYNAME":
        DisplayName = AllBounds(tmpLine)
      Case "PASSWORD":
        Password = AllBounds(tmpLine)
      Case "PORT"
        ConnectPort = AllBounds(tmpLine)
      Case "DESCRIPTION":
        Description = AllBounds(tmpLine)
      Case "NICKSERV:VHOST"
        NickServ_VHost = AllBounds(tmpLine)
      Case "NICKSERV:ENABLEVHOST"
        NickServ_VHostEnable = CBool(AllBounds(tmpLine))
      Case "NICKSERV:VHOSTSTYLE"
        NickServ_VHostStyle = CLng(AllBounds(tmpLine))
    End Select
NextLine:
  Loop Until EOF(F)
  Close #F
Else
  Open App.Path & "\services.conf" For Output As F
    Print #F, "; ignitionServices Configuration File"
    Print #F, "[General]"
    Print #F, "NickServ=1"
    Print #F, "ChanServ=1"
    Print #F, "MemoServ=1"
    Print #F, "OperServ=1"
    Print #F, "[Connection]"
    Print #F, "Server=127.0.0.1"
    Print #F, "DisplayName=services.localhost"
    Print #F, "Password=1234"
    Print #F, "Description=ignitionServices - The only open source standalone IRCX services for Windows"
    Print #F, "Port=6667"
    Print #F, "NickServ:VHost=registered.example.com"
    Print #F, "NickServ:EnableVHost=0"
    Print #F, "NickServ:VHostStyle=0"
  Close #1
  GoTo Beginning
End If
frmHome.txtDisplayName.Text = DisplayName
frmHome.txtServerAddress.Text = Server
frmHome.txtLinkPassword.Text = Password
frmHome.txtPort.Text = ConnectPort
frmHome.txtDescription.Text = Description
frmNS.chkEnableNickServ.Value = ToInt(NickServ)
frmNS.cVHost.Value = ToInt(NickServ_VHostEnable)
frmNS.txtVHost.Text = NickServ_VHost
InternalDebug "VHostStyle: '" & NickServ_VHostStyle & "'"
If NickServ_VHostStyle = 0 Then
  frmNS.oNickVH.Value = True
  frmNS.oMNickVH.Value = False
  frmNS.oVH.Value = False
ElseIf NickServ_VHostStyle = 1 Then
  frmNS.oNickVH.Value = False
  frmNS.oMNickVH.Value = True
  frmNS.oVH.Value = False
ElseIf NickServ_VHostStyle = 2 Then
  frmNS.oNickVH.Value = False
  frmNS.oMNickVH.Value = False
  frmNS.oVH.Value = True
End If
frmCS.chkEnableChanServ.Value = ToInt(ChanServ)
frmServerConfig.Default
On Error Resume Next
If Dir(App.Path & "\ChanServ\") = vbNullString Then MkDir App.Path & "\ChanServ"
If Dir(App.Path & "\NickServ\") = vbNullString Then MkDir App.Path & "\NickServ"
End Sub

Private Sub MDIForm_QueryUnload(Cancel As Integer, UnloadMode As Integer)
frmHome.ForceClose = True
Unload frmHome
frmCS.ForceClose = True
Unload frmCS
frmNS.ForceClose = True
Unload frmNS
frmServerConfig.ForceClose = True
Unload frmServerConfig
End Sub

Public Function ToInt(boolValue As Boolean) As Integer
If boolValue = True Then ToInt = 1 Else ToInt = 0
End Function

Private Sub MDIForm_Unload(Cancel As Integer)
Dim F As Integer
F = FreeFile
InternalDebug "*** saving config!"
Open App.Path & "\services.conf" For Output As F
    Print #F, "; ignitionServices Configuration File"
    Print #F, "[General]"
    Print #F, "NickServ=" & ToInt(NickServ)
    Print #F, "ChanServ=" & ToInt(ChanServ)
    Print #F, "MemoServ=" & ToInt(MemoServ)
    Print #F, "OperServ=" & ToInt(OperServ)
    Print #F, "[Connection]"
    Print #F, "Server=" & Server
    Print #F, "DisplayName=" & DisplayName
    Print #F, "Password=" & Password
    Print #F, "Description=" & Description
    Print #F, "Port=" & ConnectPort
    Print #F, "NickServ:VHost=" & NickServ_VHost
    Print #F, "NickServ:EnableVHost=" & CInt(NickServ_VHostEnable)
    Print #F, "NickServ:VHostStyle=" & CInt(NickServ_VHostStyle)
Close #F
End
End Sub

Private Sub mnuChanServ_Click()
frmCS.Hide
frmCS.Show
End Sub

Private Sub mnuConnect_Click()
frmHome.ToggleConnection
End Sub

Private Sub mnuDisconnect_Click()
frmHome.ToggleConnection
End Sub

Private Sub mnuMain_Click()
frmHome.Hide
frmHome.Show
End Sub

Private Sub mnuNickServ_Click()
frmNS.Hide
frmNS.Show
End Sub

Private Sub mnuServerConfig_Click()
frmServerConfig.Hide
frmServerConfig.Show
End Sub


Private Sub timNoMax_Timer()
If WindowState = 1 Then
  'they minimized
  Dim Handle As Long
  With nidIcon
      .cbSize = Len(nidIcon)
      .hwnd = frmMain.picTray.hwnd
      .uFlags = NIF_ICON Or NIF_TIP Or NIF_MESSAGE
      .uCallbackMessage = WM_LBUTTONDOWN
      .hIcon = frmMain.picTray.Picture.Handle
      .szTip = "ignitionServices" & vbNullChar
  End With
  'add the icon to the tray
  Shell_NotifyIcon NIM_ADD, nidIcon
  InTray = True
  Hide
  Exit Sub
End If
If WindowState <> 1 And InTray = True Then
  Shell_NotifyIcon NIM_DELETE, nidIcon
  Show
  InTray = False
End If
End Sub
Private Sub picTray_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
Select Case CLng(x \ Screen.TwipsPerPixelX)
      Case WM_LBUTTONDBLCLK
        WindowState = 0
        Show
      Case WM_RBUTTONUP
        'PopupMenu mnuContext, , , , mnuShow
        WindowState = 0
        Show
End Select
End Sub
Private Sub wsMain_Close()
InternalDebug "Socket Closed"
wsMain.Close
frmHome.cmdConnect.Caption = "&Connect"
mnuConnect.Enabled = True
mnuDisconnect.Enabled = False
End Sub

Private Sub wsMain_Connect()
wsMain.SendData "PASS " & Password & vbCrLf
Debug.Print "Sent: PASS " & Password
wsMain.SendData "SERVER " & DisplayName & " 1 :" & Description & vbCrLf
Debug.Print "Sent: SERVER " & DisplayName & " 1 :" & Description & vbCrLf
End Sub

Private Sub wsMain_DataArrival(ByVal bytesTotal As Long)
Dim strData As String
Dim aData() As String
Dim A As Integer
wsMain.GetData strData, vbString
InternalDebug "Recv: " & strData
DataCache = DataCache & strData
'change all of the CRLFs and CRs to LFs
DataCache = Replace(DataCache, vbCrLf, vbLf)
DataCache = Replace(DataCache, vbCr, vbLf)
DataCache = Replace(DataCache, vbLf & vbLf, vbLf)
If Right(DataCache, Len(vbLf)) = vbLf Then
  aData = Split(DataCache, vbLf)
  For A = LBound(aData) To UBound(aData)
    Call ProcData(aData(A))
  Next A
  DataCache = ""
End If
End Sub
Function RightOf(strData As String, strDelim As String) As String
    If Left(strData, 1) = ":" Then strData = Right(strData, Len(strData) - 1)
    Dim intPos As Integer
    intPos = InStr(strData, strDelim)
    
    If intPos Then
        RightOf = Mid(strData, intPos + 1, Len(strData) - intPos)
    Else
        RightOf = strData
    End If
End Function
Public Sub ProcData(strData As String)
'On Error Resume Next
Dim A As Long
Dim Prefix As String
Dim tmpFounder As String
Dim NumParams As Long
If strData = "" Then Exit Sub
Prefix = Split(strData, " ")(0)
NumParams = UBound(Split(strData, " "))
If UCase$(Split(strData, " ")(0)) = "PING" Then
  wsMain.SendData "PONG :" & Split(strData, " ")(1) & vbCrLf
  Exit Sub
End If
Select Case UCase(Split(strData, " ")(1))
  Case "NICK":
    If NickRegistered(Replace(CStr(Split(strData, " ")(2)), ":", "")) And Not GetOnline(Replace(CStr(Split(strData, " ")(2)), ":", "")) Then
      wsMain.SendData ":NickServ NOTICE " & Replace(CStr(Split(strData, " ")(2)), ":", "") & " :This nickname is registered and protected. If it is your" & vbCrLf
      wsMain.SendData ":NickServ NOTICE " & Replace(CStr(Split(strData, " ")(2)), ":", "") & " :nick, type /NickServ IDENTIFY password. Otherwise," & vbCrLf
      wsMain.SendData ":NickServ NOTICE " & Replace(CStr(Split(strData, " ")(2)), ":", "") & " :please choose a different nick." & vbCrLf
    End If
    
    ':Nick NICK Nick2
    ' 0     1     2
    If NumParams <= 2 Then
      'rename the user...
      RenameOwnerAllChans CStr(Replace(Prefix, ":", "")), Replace(CStr(Split(strData, " ")(2)), ":", "")
      RenameHostAllChans CStr(Replace(Prefix, ":", "")), Replace(CStr(Split(strData, " ")(2)), ":", "")
      RenameUserAllChans CStr(Replace(Prefix, ":", "")), Replace(CStr(Split(strData, " ")(2)), ":", "")
      
      'the following should only affect users who are changing their nick
      'they are no longer +r if they do
      If GetOnline(Replace(Prefix, ":", "")) Then
        Call DelOnline(Replace(Prefix, ":", ""))
        wsMain.SendData ":" & Replace(CStr(Split(strData, " ")(2)), ":", "") & " MODE " & Replace(CStr(Split(strData, " ")(2)), ":", "") & " -r " & Replace(CStr(Split(strData, " ")(2)), ":", "") & vbCrLf
      End If
    End If
  Case "NJOIN":
    'record channels when connecting
    ':ignition.servebeer.com NJOIN #Ziggy :.Ziggy
    Dim tmpChan As String
    Dim tmpUsers As String
    Dim tmpUserArr() As String
    tmpChan = Split(strData, " ")(2)
    tmpUsers = RightOf(strData, ":")
    AddChannel tmpChan
    If Len(tmpUsers) > 0 Then
      tmpUserArr() = Split(tmpUsers, " ")
      For A = 0 To UBound(tmpUserArr)
        AddUserToChan tmpChan, Replace(Replace(Replace(tmpUserArr(A), "+", ""), "@", ""), ".", "")
        If Left(tmpUserArr(A), 1) = "." Then
          'the user is an owner
          AddOwnerToChan tmpChan, Replace(Replace(Replace(tmpUserArr(A), "+", ""), "@", ""), ".", "")
        ElseIf Left(tmpUserArr(A), 1) = "@" Then
          AddHostToChan tmpChan, Replace(Replace(Replace(tmpUserArr(A), "+", ""), "@", ""), ".", "")
        End If
      Next A
    End If
    If ChanRegistered(tmpChan) Then
      tmpFounder = GetChanProp(tmpChan, "Founder")
      If GetOnline(tmpFounder) And IsUser(tmpChan, tmpFounder) Then
        'owner the founder in a netsplit or something
        'this code is illogical here unless they can identify faster than we can get the NJOINs
        'although it's possible that this could be of some use somehow :/
        wsMain.SendData ":ChanServ MODE " & tmpChan & " +q " & tmpFounder & vbCrLf
      End If
      wsMain.SendData ":ChanServ MODE " & tmpChan & " +r" & vbCrLf
      wsMain.SendData ":ChanServ PROP " & tmpChan & " OWNERKEY :" & GetChanProp(tmpChan, "OwnerKey") & vbCrLf
      wsMain.SendData ":ChanServ PROP " & tmpChan & " ACCOUNT :" & GetChanProp(tmpChan, "Founder") & vbCrLf
      If Len(GetChanProp(tmpChan, "Welcome")) > 0 Then
        wsMain.SendData ":ChanServ PROP " & tmpChan & " ONJOIN :" & GetChanProp(tmpChan, "Welcome") & vbCrLf
      End If
    End If
  Case "MODE":
    ':Ziggy MODE #Ziggy +q Nick
    Dim tmpS() As String
    Dim tmpCrap As String
    Dim I As Long
    Dim Inc As Long
    Dim Mask As String
    Dim NM As String
    Dim MU As String
    Dim MSwitch As Boolean
    tmpCrap = Split(strData, " ")(0) & " " & Split(strData, " ")(1) & " "
    tmpS() = Split(Mid(strData, Len(tmpCrap) + 1), " ")
    InternalDebug "tmpS()*: '" & Mid(strData, Len(tmpCrap) + 1) & "'"
    InternalDebug "tmpCrap: '" & tmpCrap & "'"
    
    'der, this obviously can't work ^_^
    'If ChanRegistered(CStr(Split(strData, " ")(2))) Then
        If UBound(tmpS) > 1 Then Inc = 1
        For I = 1 To Len(tmpS(1))
          Mask = Mid$(tmpS(1), I, 1)
          InternalDebug "mask: '" & Mask & "'"
          Select Case AscW(Mask)
              Case Asc("+")
                  MSwitch = True
                  NM = NM & "+"
              Case Asc("-")
                  MSwitch = False
                  NM = NM & "-"
              Case Asc("q")
                  Inc = Inc + 1
                  If MSwitch Then
                    AddOwnerToChan CStr(Split(strData, " ")(2)), tmpS(Inc)
                  Else
                    RemoveOwnerFromChan CStr(Split(strData, " ")(2)), tmpS(Inc)
                  End If
                  MU = MU & " " & tmpS(Inc)
                  NM = NM & "q"
              Case Asc("o")
                  Inc = Inc + 1
                  If MSwitch Then
                    AddHostToChan CStr(Split(strData, " ")(2)), tmpS(Inc)
                  Else
                    RemoveHostFromChan CStr(Split(strData, " ")(2)), tmpS(Inc)
                  End If
                  MU = MU & " " & tmpS(Inc)
                  NM = NM & "o"
          End Select
        Next I
        MU = LTrim$(MU)
    'End If
  Case "PART":
    ':Ziggy PART #Ziggy :Ziggy
    RemoveUserFromChan CStr(Split(strData, " ")(2)), CStr(Right(Split(strData, " ")(0), Len(Split(strData, " ")(0)) - 1))
    If IsOwner(CStr(Split(strData, " ")(2)), CStr(Right(Split(strData, " ")(0), Len(Split(strData, " ")(0)) - 1))) Then
      RemoveOwnerFromChan CStr(Split(strData, " ")(2)), CStr(Right(Split(strData, " ")(0), Len(Split(strData, " ")(0)) - 1))
    End If
    If IsHost(CStr(Split(strData, " ")(2)), CStr(Right(Split(strData, " ")(0), Len(Split(strData, " ")(0)) - 1))) Then
      RemoveHostFromChan CStr(Split(strData, " ")(2)), CStr(Right(Split(strData, " ")(0), Len(Split(strData, " ")(0)) - 1))
    End If
  Case "JOIN":
    'record users joining channels
    ':Ziggy JOIN #Ziggy
    Dim tmpM As String
    Dim tmpFL As Boolean
    Dim tmpIU As Boolean
    Dim tmpUsr As String
    Dim tmpChn As String
    
    If ChanExist(CStr(Split(strData, " ")(2))) Then
      AddUserToChan CStr(Split(strData, " ")(2)), CStr(Right(Split(strData, " ")(0), Len(Split(strData, " ")(0)) - 1))
      'this mess basically does this:
      'If the founder is logged on,
      'and the current user is a member of the channel,
      'and the current user's master nick is equal to that of the founder
      tmpUsr = CStr(Right(Split(strData, " ")(0), Len(Split(strData, " ")(0)) - 1))
      tmpChn = CStr(Split(strData, " ")(2))
      tmpM = GetMasterNick2(tmpUsr)
      tmpFL = GetOnline(GetChanProp(tmpChn, "Founder"))
      tmpIU = IsUser(tmpChn, tmpUsr)
      InternalDebug "JOIN -- Channel Exists"
      If ChanRegistered(tmpChn) Then
        If tmpFL And tmpIU And (UCase(tmpM) = UCase(GetChanProp(tmpChn, "Founder"))) Then
          wsMain.SendData ":ChanServ MODE " & Split(strData, " ")(2) & " +q " & tmpUsr & vbCrLf
          AddOwnerToChan tmpChn, tmpUsr
          InternalDebug "JOIN -- Channel Exists -- User is Founder"
        Else
          InternalDebug "JOIN -- Channel Exists -- User is not founder"
        End If
      End If
    Else
      AddChannel CStr(Split(strData, " ")(2))
      AddUserToChan CStr(Split(strData, " ")(2)), CStr(Right(Split(strData, " ")(0), Len(Split(strData, " ")(0)) - 1))
      'this mess basically does this:
      'If the founder is logged on,
      'and the current user is a member of the channel,
      'and the current user's master nick is equal to that of the founder
      tmpUsr = CStr(Right(Split(strData, " ")(0), Len(Split(strData, " ")(0)) - 1))
      tmpChn = CStr(Split(strData, " ")(2))
      tmpM = GetMasterNick2(tmpUsr)
      tmpFL = GetOnline(GetChanProp(tmpChn, "Founder"))
      tmpIU = IsUser(tmpChn, tmpUsr)
      If ChanRegistered(CStr(Split(strData, " ")(2))) Then
        If tmpFL And tmpIU And (UCase(tmpM) = UCase(GetChanProp(tmpChn, "Founder"))) Then
          wsMain.SendData ":ChanServ MODE " & Split(strData, " ")(2) & " +q " & tmpUsr & vbCrLf
          AddOwnerToChan tmpChn, tmpUsr
          InternalDebug "JOIN -- Creating Channel -- User Is Founder"
        Else
          'in a registered channel, only the founder should get owner if the channel recreates
          'this -q's people who aren't founders
          wsMain.SendData ":ChanServ MODE " & Split(strData, " ")(2) & " -q " & CStr(Right(Split(strData, " ")(0), Len(Split(strData, " ")(0)) - 1)) & vbCrLf
          InternalDebug "JOIN -- Creating Channel -- User Is Not Founder"
        End If
        wsMain.SendData ":ChanServ MODE " & Split(strData, " ")(2) & " +r" & vbCrLf
        wsMain.SendData ":ChanServ PROP " & Split(strData, " ")(2) & " OWNERKEY :" & GetChanProp(CStr(Split(strData, " ")(2)), "OwnerKey") & vbCrLf
        wsMain.SendData ":ChanServ PROP " & Split(strData, " ")(2) & " ACCOUNT :" & GetChanProp(CStr(Split(strData, " ")(2)), "Founder") & vbCrLf
        If Len(GetChanProp(CStr(Split(strData, " ")(2)), "Welcome")) > 0 Then
          wsMain.SendData ":ChanServ PROP " & CStr(Split(strData, " ")(2)) & " ONJOIN :" & GetChanProp(CStr(Split(strData, " ")(2)), "Welcome") & vbCrLf
        End If
      Else
        'channel isn't registered, and didn't exist before
        AddUserToChan CStr(Split(strData, " ")(2)), CStr(Right(Split(strData, " ")(0), Len(Split(strData, " ")(0)) - 1))
        AddOwnerToChan CStr(Split(strData, " ")(2)), CStr(Right(Split(strData, " ")(0), Len(Split(strData, " ")(0)) - 1))
        InternalDebug "JOIN -- Creating Unregistered Channel"
      End If
    End If
  Case "KICK":
    ':Ziggy KICK #Room Nick :Reason
    RemoveUserFromChan CStr(Split(strData, " ")(2)), CStr(Split(strData, " ")(3))
    If IsOwner(CStr(Split(strData, " ")(2)), CStr(Split(strData, " ")(3))) Then
      RemoveOwnerFromChan CStr(Split(strData, " ")(2)), CStr(Split(strData, " ")(3))
    End If
    If IsHost(CStr(Split(strData, " ")(2)), CStr(Split(strData, " ")(3))) Then
      RemoveHostFromChan CStr(Split(strData, " ")(2)), CStr(Split(strData, " ")(3))
    End If
  Case "QUIT":
    If GetOnline(CStr(Right(Prefix, Len(Prefix) - 1))) Then
      'if the user was logged in, remove the record of him
      Call DelOnline(CStr(Right(Prefix, Len(Prefix) - 1)))
    End If
    'kill the user's data
    'like you would a spider, but this is obviously not a spider
    RemoveOwnerAllChans CStr(Right(Prefix, Len(Prefix) - 1))
    RemoveHostAllChans CStr(Right(Prefix, Len(Prefix) - 1))
    RemoveUserAllChans CStr(Right(Prefix, Len(Prefix) - 1))
  Case "SERVER":
    'be aware of other servers, again useless, but we might find some useful
    'data here -- like "are we connected?"
    If Split(strData, " ")(2) = DisplayName Then
      'we connected
      InternalDebug "We connected"
      If NickServ = True Then wsMain.SendData "NICK NickServ 1 " & CTime & " NickServ " & DisplayName & " " & DisplayName & " :Nickname Registration Services" & vbCrLf
      If NickServ = True Then wsMain.SendData ":NickServ MODE NickServ +S" & vbCrLf
      If ChanServ = True Then wsMain.SendData "NICK ChanServ 1 " & CTime & " ChanServ " & DisplayName & " " & DisplayName & " :Channel Registration Services" & vbCrLf
      If ChanServ = True Then wsMain.SendData ":ChanServ MODE ChanServ +S" & vbCrLf
      If MemoServ = True Then wsMain.SendData "NICK MemoServ 1 " & CTime & " MemoServ " & DisplayName & " " & DisplayName & " :Message/Note Services" & vbCrLf
      If MemoServ = True Then wsMain.SendData ":MemoServ MODE MemoServ +S" & vbCrLf
      If OperServ = True Then wsMain.SendData "NICK OperServ 1 " & CTime & " OperServ " & DisplayName & " " & DisplayName & " :Operator Services" & vbCrLf
      If OperServ = True Then wsMain.SendData ":OperServ MODE OperServ +S" & vbCrLf
      If OperServ = True Then wsMain.SendData ":OperServ GNOTICE :ignitionServices are now running." & vbCrLf
    End If
  Case "KILL"
    'in case some retarded oper kills a service :P
    If (UCase$(Split(strData, " ")(3)) = ":NICKNAME") And (UCase$(Split(strData, " ")(4)) = "COLLISION") Then
      If Not ShownCollision Then MsgBox "There has been a nickname collision within services. Most likely, somewhere on the network, someone tried to connect services. Please check the problem and re-connect."
      ShownCollision = True
      frmHome.cmdConnect.Caption = "&Connect"
      mnuConnect.Enabled = True
      mnuDisconnect.Enabled = False
      wsMain.Close
      Exit Sub
    End If
    Select Case UCase$(Split(strData, " ")(2))
      Case "OPERSERV"
        If OperServ = True Then wsMain.SendData "NICK OperServ 1 " & CTime & " OperServ " & DisplayName & " " & DisplayName & " :Operator Services" & vbCrLf
        If OperServ = True Then wsMain.SendData ":OperServ MODE OperServ +S" & vbCrLf
      Case "NICKSERV"
        If NickServ = True Then wsMain.SendData "NICK NickServ 1 " & CTime & " NickServ " & DisplayName & " " & DisplayName & " :Nickname Registration Services" & vbCrLf
        If NickServ = True Then wsMain.SendData ":NickServ MODE NickServ +S" & vbCrLf
      Case "CHANSERV"
        If ChanServ = True Then wsMain.SendData "NICK ChanServ 1 " & CTime & " ChanServ " & DisplayName & " " & DisplayName & " :Channel Registration Services" & vbCrLf
        If ChanServ = True Then wsMain.SendData ":ChanServ MODE ChanServ +S" & vbCrLf
      Case "MEMOSERV"
        If MemoServ = True Then wsMain.SendData "NICK MemoServ 1 " & CTime & " MemoServ " & DisplayName & " " & DisplayName & " :Message/Note Services" & vbCrLf
        If MemoServ = True Then wsMain.SendData ":MemoServ MODE MemoServ +S" & vbCrLf
    End Select
  Case "PRIVMSG"
    'the way we process commands :D
    If UCase(Split(strData, " ")(2)) = "NICKSERV" And NickServ = True Then
      Call ProcNickServ(RightOf(CStr(Split(strData, " ")(0)), ":"), RightOf(strData, ":"))
    ElseIf UCase(Split(strData, " ")(2)) = "CHANSERV" And ChanServ = True Then
      Call ProcChanServ(RightOf(CStr(Split(strData, " ")(0)), ":"), RightOf(strData, ":"))
    End If
  Case "VERSION"
    '/version server
    'Out: :server 351 nick ignitionServices-version-build-cvs.0 server :description
    'In: :nick VERSION :server
    wsMain.SendData ":" & DisplayName & " 351 " & RightOf(CStr(Split(strData, " ")(0)), ":") & " ignitionServices-" & App.Major & "." & App.Minor & "." & App.Revision & "." & Version & ".0 " & DisplayName & " :ignitionServices " & App.Major & "." & App.Minor & "." & App.Revision & " (http://www.ignition-project.com/)" & vbCrLf
End Select
End Sub
Private Sub wsMain_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
InternalDebug "Error " & Number & " - " & Description
CancelDisplay = True
wsMain.Close
frmHome.cmdConnect.Caption = "&Connect"
mnuConnect.Enabled = True
mnuDisconnect.Enabled = False
MsgBox "ignitionServices failed to connect to the IRC server for the following reason:" & vbCrLf & vbCrLf & Description & " (" & Number & ")" & vbCrLf & vbCrLf & "Please check your configuration and try again.", vbCritical, "Connection Error"
End Sub
Private Sub MDIForm_Load()
InternalDebug "*** MDIForm_Load"
   ReDim OnlineUsers(0)
   frmNS.Show
   frmNS.Height = 5925
   frmNS.Width = 4860
   frmCS.Show
   frmCS.Height = 5925
   frmCS.Width = 4860
   frmServerConfig.Show
   frmServerConfig.Height = 5925
   frmServerConfig.Width = 4860
   frmHome.Show
   frmHome.Height = 5925
   frmHome.Width = 4860
   frmHome.WindowState = 2
Call LoadConfiguration
End Sub
